import { ReactNode } from 'react';
import { RemeshQueryAction, RemeshEvent, RemeshDomainAction, RemeshStore, Serializable, RemeshStoreOptions, Args, RemeshSubscribeOnlyEvent } from 'remesh';
export type RemeshReactContext = {
    remeshStore: RemeshStore;
};
export declare const RemeshReactContext: import("react").Context<RemeshReactContext | null>;
export declare const useRemeshReactContext: () => RemeshReactContext;
export declare const useRemeshStore: () => RemeshStore;
export type RemeshRootProps = {
    children: ReactNode;
    store?: RemeshStore;
} | {
    children: ReactNode;
    store?: never;
    options: RemeshStoreOptions;
};
export declare const RemeshRoot: (props: RemeshRootProps) => JSX.Element;
export declare const useRemeshQuery: <T extends Args<Serializable>, U>(queryAction: RemeshQueryAction<T, U>) => U;
export declare const useRemeshEvent: <T extends Args, U>(Event: RemeshEvent<T, U> | RemeshSubscribeOnlyEvent<T, U>, callback: (data: U) => unknown) => void;
export declare const useRemeshSend: () => (output: import("remesh").RemeshAction) => void;
export declare const useRemeshDomain: <T extends Partial<import("remesh").RemeshDomainOutput>, U extends Args<Serializable>>(domainAction: RemeshDomainAction<T, U>) => import("remesh").VerifiedRemeshDomainDefinition<T>;
export type RemeshDomainHolderContainerProps = {
    domains: RemeshDomainAction<any, any>[];
};
export declare const RemeshDomainHolderContainer: (props: RemeshDomainHolderContainerProps) => JSX.Element;
export type RemeshScopeProps = {
    domains: RemeshDomainAction<any, any>[];
    children: ReactNode;
};
export declare const RemeshScope: (props: RemeshScopeProps) => JSX.Element;
